// SWXCH01.h : Declaration of the CSWXCH01

#pragma once
#include "resource.h"       // main symbols

#include "SWArcExchange.h"


// CSWXCH01

class ATL_NO_VTABLE CSWXCH01 :
   public CComObjectRootEx<CComSingleThreadModel>,
   public CComCoClass<CSWXCH01, &CLSID_SWXCH01>,
   public ISWXCH01
{
public:
   CSWXCH01()
   {
   }

DECLARE_REGISTRY_RESOURCEID(IDR_SWXCH01)


BEGIN_COM_MAP(CSWXCH01)
   COM_INTERFACE_ENTRY(ISWXCH01)
END_COM_MAP()


   DECLARE_PROTECT_FINAL_CONSTRUCT()

   HRESULT FinalConstruct()
   {
      return S_OK;
   }

   void FinalRelease()
   {
   }

private:

   // Properties

   TicsHandle thHandle;
   SGrinder sg;

   // Methods

   int BuildPoint(IGeometry ** igValue);
   int BuildLine(IGeometry ** igValue);
   int BuildPoly(IGeometry ** igValue);
   void PutPoint(IGeometry * igValue);
   void PutLine(IGeometry * igValue);
   void PutPoly(IGeometry * igValue);
   void PutPath(IGeometry * igPath);
   void GrindPath(IGeometry * igPath, IPointCollection ** ipPath);

public:

   STDMETHOD(Connect)(/*[in]*/ BSTR ServerName, /*[out,retval]*/ LONG* Result);
   STDMETHOD(SetView)(/*[in]*/ BSTR ViewName, /*[out,retval]*/ LONG* Result);
   STDMETHOD(SetTable)(/*[in]*/ BSTR TableName, /*[out,retval]*/ LONG* Result);
   STDMETHOD(RemoveTable)(/*[out,retval]*/ LONG* Result);
   STDMETHOD(ApplySimplePredicate)(/*[in]*/ BSTR FieldName, /*[in]*/ BSTR Operator, /*[in]*/ BSTR StringValue, /*[in]*/ BSTR Option, /*[out,retval]*/ LONG* Result);
   STDMETHOD(ApplyExtent)(/*[in]*/ BSTR FieldName, /*[in]*/ DOUBLE XMin, /*[in]*/ DOUBLE YMin, /*[in]*/ DOUBLE XMax, /*[in]*/ DOUBLE YMax, /*[in]*/ BOOL IncludeOverlaps, /*[in]*/ BSTR Option, /*[out,retval]*/ LONG* Result);
   STDMETHOD(ApplyTrail)(/*[in]*/ BSTR FieldName, /*[in]*/ BSTR AppName, /*[in]*/ BOOL IncludeOverlaps, /*[in]*/ BSTR Option, /*[out,retval]*/ LONG* Result);
   STDMETHOD(ClearPredicate)(/*[out,retval]*/ LONG* Result);
   STDMETHOD(GetNextRecord)(/*[out,retval]*/ LONG* Result);
   STDMETHOD(GetJoin)(/*[in]*/ BSTR FieldName, /*[out,retval]*/ LONG* Result);
   STDMETHOD(GetString)(/*[in]*/ BSTR FieldName, /*[out]*/ BSTR* Value, /*[out,retval]*/ LONG* Result);
   STDMETHOD(GetGeometry)(/*[in]*/ BSTR FieldName, /*[out]*/ IGeometry ** Value, /*[out,retval]*/ LONG* Result);
   STDMETHOD(GetAnnotation)(/*[in]*/ BSTR FieldName, /*[out]*/ ITextElement ** Value, /*[out,retval]*/ LONG* Result);
   STDMETHOD(GetDimension)(/*[in]*/ BSTR FieldName, /*[out]*/ IGeometry ** LineValue, /*[out]*/ ITextElement ** AnnoValue, /*[out,retval]*/ LONG* Result);
   STDMETHOD(Delete)(/*[out,retval]*/ LONG* Result);
   STDMETHOD(NewDetachedRecord)(/*[out,retval]*/ LONG* Result);
   STDMETHOD(InsertRecord)(/*[out,retval]*/ LONG* Result);
   STDMETHOD(NewDatalessRWO)(/*[in]*/ DOUBLE XMin, /*[in]*/ DOUBLE YMin, /*[in]*/ DOUBLE XMax, /*[in]*/ DOUBLE YMax, /*[out,retval]*/ LONG* Result);
   STDMETHOD(PutJoin)(/*[in]*/ BSTR FieldName, /*[in]*/ BSTR Direction, /*[out,retval]*/ LONG* Result);
   STDMETHOD(PutString)(/*[in]*/ BSTR FieldName, /*[in]*/ BSTR Value, /*[out,retval]*/ LONG* Result);
   STDMETHOD(PutGeometry)(/*[in]*/ BSTR FieldName, /*[in]*/ IGeometry * Value, /*[out,retval]*/ LONG* Result);
   STDMETHOD(PutAnnotation)(/*[in]*/ BSTR FieldName, /*[in]*/ IPoint * Coord1, /*[in]*/ BSTR Text, /*[in]*/ DOUBLE Orientation, /*[in]*/ LONG Justification, /*[out,retval]*/ LONG* Result);
   STDMETHOD(PutDimension)(/*[in]*/ BSTR FieldName, /*[in]*/ LONG Type, /*[in]*/ BSTR Text, /*[in]*/ IPointCollection * ControlPoints, /*[out,retval]*/ LONG* Result);
   STDMETHOD(Disconnect)();

};

OBJECT_ENTRY_AUTO(__uuidof(SWXCH01), CSWXCH01)
